/*
Copyright (c) 2004 Dmitry Markman, PhD dmarkman@mac.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package org.dm.webkit;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

import javax.swing.*;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent;

import org.w3c.dom.*;

import org.dm.webkit.*;
import org.dm.webkit.dom.*;


public class WebKitJava  extends DMWebKitView {
    
    private Frame owner;
    protected JButton stopButton;
    protected JButton backButton;
    protected JButton forwardButton;
    protected JTextField urlStringTextField;
    public JLabel statusMessageLabel;
    protected IconHolder iconHolder = new IconHolder();
    int     nsObject = 0;
    
    public int createNSView(){
        nsObject = createNSView1();
        return nsObject;
    }
    public native int createNSView1();
    
    public static WebKitJava webKitView;
    
    public Object notifyObject = new Object();
    
    public WebKitJava(){
    	super();
    	owner = null;
        iconHolder.setBackground(new Color(255,255,255));
    }
   
    public WebKitJava(Frame owner){
    	this();
        this.owner = owner;
    }

    public void setOwner(Frame owner){
        this.owner = owner;
    }
    
    public int createNewWebKit(){
        final Frame f = new Frame("");
        f.setLayout(new BorderLayout());
        f.setBounds(100, 100, INIT_WIDTH, INIT_HEIGHT);
        WebKitJava newView = new WebKitJava(f);
        f.add(newView,BorderLayout.CENTER);

        Panel controlPanel = new Panel();
        controlPanel.setLayout(new BorderLayout());
        JLabel statusMessageLabel = new JLabel("",JLabel.LEFT); 
        statusMessageLabel.setPreferredSize(new Dimension(f.getSize().width,20));      
        controlPanel.add(statusMessageLabel,BorderLayout.CENTER);
        f.add(controlPanel,BorderLayout.SOUTH);
        newView.setStatusMessageLabel(statusMessageLabel);
        newView.setNewWebViewCreatingPolicy(getNewWebViewCreatingPolicy());
        f.setVisible(true);
        f.addWindowListener(new WindowAdapter(){
            public void windowClosed(WindowEvent evt){
                f.setVisible(false);
                f.dispose();
            }
            public void windowClosing(WindowEvent evt){
                f.setVisible(false);
                f.dispose();
            }
        });
        newView.requestFocusInWindow();
        newView.needResize = true;
        //newView.loadURL("http://www.apple.com");
        return newView.nsObject;
    }
    
    public Frame getOwner(){return owner;}
//http://www.dataway.ch/~bennet/java/3DClock.html    
    protected static boolean  restartForApplet(){
        boolean success = false;
        try{
            StringBuffer sb = new StringBuffer();
            String needPrefix = "file:";
            String className = "/"+WebKitJava.class.getName().replace('.','/')+".class";
            java.net.URL classURL = WebKitJava.class.getResource(className);
            String path = classURL.getPath();
            if(!path.startsWith(needPrefix)) return success;
            int indexOfEx = path.indexOf('!');
            if(indexOfEx < 0) return success;
            String jarURL = path.substring(0,indexOfEx);
            String jarName = (new java.net.URL(jarURL)).getPath();
            jarName = java.net.URLDecoder.decode(jarName,"US-ASCII");
            String []newArgs = new String[5];
            newArgs[0] = "java";
//          newArgs[1] = "-Xbootclasspath/p:/Library/Java/Home/lib/jaws.jar:/Library/Java/Home/lib/netscape.jar:/Library/Java/Home/lib/ext/apple_provider.jar:/Library/Internet Plug-Ins/JavaPluginCocoa.bundle/Contents/Resources/AppletsInCocoa.jar";
            newArgs[1] = "-Xbootclasspath/p:/Library/Java/Home/lib/jaws.jar:/Library/Java/Home/lib/netscape.jar:/Library/Java/Home/lib/ext/apple_provider.jar";
            newArgs[2] = "-cp";
            newArgs[3] = jarName;
            newArgs[4] = "org.dm.webkit.WebKitJava";
            System.out.println("before "+jarName);
            Runtime.getRuntime().exec(newArgs);
            System.out.println("after");
            success = true;
        }catch(Throwable t){
            System.out.println("restartForApplet Throwable "+t);
            success = false;
        }
        
               
                      
        return success;
    }
    
    public static void main(String args[]) {
        boolean restartForApplet = false;
        restartForApplet = (args != null && args.length == 1 && args[0].equals("forapplet"));
        if(restartForApplet){
            boolean success = restartForApplet();
            if(success) return;
        }
        Frame f = new Frame("Simple Java web browser");
        f.setLayout(new BorderLayout());
        f.setBounds(100, 100, INIT_WIDTH, INIT_HEIGHT);
        webKitView = new WebKitJava(f);
        //webKitView.setNewWebViewCreatingPolicy(WEB_VIEW_POLICY_IN_OLD_WINDOW);
        webKitView.setNewWebViewCreatingPolicy(WEB_VIEW_POLICY_NONE);
        
        Panel urlPanel = new Panel();
        urlPanel.setLayout(new BorderLayout());
/*
        urlString = new TextField("http://www.apple.com");
        urlPanel.add(urlString,BorderLayout.CENTER);
        Button goButton = new Button("Go");
        goButton.addActionListener(actionListener);
        urlPanel.add(goButton,BorderLayout.EAST);*/
        //urlString = new JTextField("http://www.apple.com");
        //urlString = new JTextField("file:///Users/dima/Sites/index.html");
        //urlString = new JTextField("file:///Users/dima/Sites/simple.html");
        //JTextField urlStringTextField = new JTextField("file:///Users/dima/Sites/nestedfont.html");
        JTextField urlStringTextField = new JTextField("http://www.concord.org");
        
        webKitView.setURLStringTextField(urlStringTextField);
        urlStringTextField.setBorder(null);
        Box boxV = Box.createVerticalBox();
        Box boxH = Box.createHorizontalBox();
        boxH.add(new JLabel("URL "));
        
        JPanel urlURI = new JPanel();
        urlURI.setLayout(new BorderLayout());
        Box urlBox = Box.createHorizontalBox();
        urlBox.add(webKitView.iconHolder);
        urlBox.add(urlStringTextField);
        urlURI.add(urlBox,BorderLayout.CENTER);
        urlURI.setBorder(BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        
        boxH.add(urlURI);
       // boxH.add(iconHolder);
       // boxH.add(urlString);
        boxV.add(boxH);
        
        
        
        boxH = Box.createHorizontalBox();
        JButton backButton = new JButton("<");
        backButton.setEnabled(false);
        webKitView.setBackButton(backButton);
        setButtonPreferredSizeWidth(backButton,40);
        boxH.add(backButton);
        JButton forwardButton = new JButton(">");
        forwardButton.setEnabled(false);
        webKitView.setForwardButton(forwardButton);
        setButtonPreferredSizeWidth(forwardButton,40);
        boxH.add(forwardButton);
        JButton reloadButton = new JButton("Reload");
        boxH.add(reloadButton);
        final JTextField urlString = urlStringTextField;
        reloadButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                webKitView.reload();
           }        
        });
        JButton stopButton = new JButton("Stop");
        webKitView.setStopButton(stopButton);
        boxH.add(stopButton);


/*
        JButton testButton = new JButton("Test");
         testButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                webKitView.invokeFromWebKitThread(new Runnable(){
                    public void run(){
 //                       testCount = 0;
 //                       webKitView.testDOM2();
                        String htmlString = "<html><head>"+
                                "<base href=\"http://dev.eclipse.org/viewcvs/index.cgi/%7Echeckout%7E/platform-swt-home/\" >"+
                                "<title>HTML Test</title></head>"+
                                "<body><a href=\"dev.html\">local link</a></body></html>";
                          webKitView.loadFromString(htmlString);
                    }
                });
           }        
        });
        boxH.add(testButton);
*/

        
        
        boxV.add(boxH);
        urlPanel.add(boxV,BorderLayout.CENTER);
        
        f.add(urlPanel,BorderLayout.NORTH);
        
        
        
   

 /*
        webKitView.addMouseMotionListener(new MouseMotionAdapter(){
            public void mouseMoved(MouseEvent evt){
                System.out.println("mouseMoved 2");
                webKitView.updateCursor();
            }
        });
*/


        f.add(webKitView,BorderLayout.CENTER);

        
        Panel controlPanel = new Panel();
        controlPanel.setLayout(new BorderLayout());
        JLabel statusMessageLabel = new JLabel("",JLabel.LEFT); 
        statusMessageLabel.setPreferredSize(new Dimension(f.getSize().width,20));      
        controlPanel.add(statusMessageLabel,BorderLayout.CENTER);
        f.add(controlPanel,BorderLayout.SOUTH);
        webKitView.setStatusMessageLabel(statusMessageLabel);
        webKitView.addListenersToButtons();
        webKitView.addListenersToURLTextField();
        f.show();
        
        webKitView.requestFocusInWindow();
        
/*
        webKitView.addHyperlinkListener(new HyperlinkListener(){
            public void hyperlinkUpdate(HyperlinkEvent evt){
                if(evt == null) return;
                HyperlinkEvent.EventType eventType = evt.getEventType();
                if(eventType == HyperlinkEvent.EventType.ACTIVATED){
                    System.out.println("ACTIVATED "+evt.getURL());
                }else if(eventType == HyperlinkEvent.EventType.ENTERED){
                    System.out.println("ENTERED "+evt.getURL());
                }else if(eventType == HyperlinkEvent.EventType.EXITED){
                    System.out.println("EXITED "+evt.getURL());
                }
            }
        });
*/
    }
    
    public void setContainerForIconHolder(JPanel container){
        if(container == null || iconHolder == null) return;
        int cCount = container.getComponentCount();
        for(int i = 0; i < cCount; i++){
            Component c = container.getComponent(i);
            if(c == iconHolder) return;
        }
        container.setLayout(null);
        container.add(iconHolder);
        iconHolder.setLocation(0,0);
    }
    
    public void setStatusMessageLabel(JLabel statusMessageLabel){
        this.statusMessageLabel = statusMessageLabel;
    }
    
    public void setStopButton(JButton stopButton){
        this.stopButton = stopButton;
    }
    
    public void setBackButton(JButton backButton){
        this.backButton = backButton;
    }
    
    public void setForwardButton(JButton forwardButton){
        this.forwardButton = forwardButton;
    }
    
    public void setURLStringTextField(JTextField urlStringTextField){
        this.urlStringTextField = urlStringTextField;
    }
    
    public void addListenersToButtons(){
        if(backButton != null){
            backButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    sendMessage(goBack);
               }        
            });
        }
        if(forwardButton != null){
            forwardButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    sendMessage(goForward);
               }        
            });
        }
        if(stopButton != null){
             stopButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    sendMessage(stopLoading);
               }        
            });   
        }    
    }
    public void addListenersToURLTextField(){
        if(urlStringTextField == null) return;
        ActionListener actionListener = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                loadURL(urlStringTextField.getText());
           }        
        };
        urlStringTextField.addActionListener(actionListener);
    }
        
    static void setButtonPreferredSizeWidth(JButton b,int needWidth){
        Dimension pbs = b.getPreferredSize();
        pbs.width = needWidth;
        b.setPreferredSize(pbs);
    }
    
    public synchronized void setError(String message){
        if(statusMessageLabel == null) return;
        statusMessageLabel.setText(message);
    }
        
    public Dimension getMaximumSize() {
        return new Dimension(Short.MAX_VALUE, Short.MAX_VALUE);
    }
    
    public Dimension getMinimumSize() {
        return new Dimension(160, 90);
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(480, 270);
    }

//callback    
    public void errorOccurred(String errorDesc, String urlString){
        setError(errorDesc+" "+urlString);
    }
    
    public void startURLLoading(String url){
        super.startURLLoading(url);
        if(urlStringTextField != null && url != null){
            urlStringTextField.setText(url);
        }
     }

    public void paint(Graphics g){
        super.paint(g);
    }

/*
    public void testNode(Document document){
        for(int i = 0; i < getChildrenCount(); i++){
           NodeWrapper nw =  getNodeWrapper(i);
           if(nw == null) continue;
           if(nw instanceof TextWrapper){
                TextWrapper text = (TextWrapper)nw;
                //((TextWrapper)nw).appendData("12345678");
                if(text.getData().startsWith("zzzzz")){//
                    //org.w3c.dom.Text newText = text.splitText(6);
                    //System.out.println("newText "+newText.getData());
                    if(org.dm.webkit.WebKitJava.testCount < 1){
                        org.w3c.dom.Element newElement = document.createElement("FONT");
                        newElement.setAttribute("color","808080");
                        newElement.setAttribute("size","+2");
                        //Node  retElement = insertBefore(newElement,text);
                        int index = getChildIndex(text);
                        Node replacedNode = replaceChild(newElement,text);
                        Node updatedNode = getChildNodes().item(index);
                        updatedNode.appendChild(replacedNode);
                        //org.w3c.dom.Text newText = document.createTextNode("dima test");
                        //Node  retText = retElement.appendChild(newText);
                        //System.out.println("retText "+retText);
                        org.dm.webkit.WebKitJava.testCount = 1;
                    }
                }
           }
           nw.testNode(document);
        }
    }
*/

    public void highlightWord(String word){
        if(word == null || word.length() < 1) return;
        TestDOMSupport testDOMSupport = new TestDOMSupport(word);
        runJS(testDOMSupport.getQuery());
    }
    
    protected void testDOM1(){
        final DOMDocument document = new DOMDocument(this);
        Element bodyElement = document.getBodyElement();
        System.out.println("Test DOM. bodyElement "+bodyElement);
        if(bodyElement == null) return;
        processNode(bodyElement,"Grokker");
    }

    private void processNode(Node node,String query){
        if(node == null || query == null) return;
        NodeList children = node.getChildNodes();
        if(children == null) return;
        for (int i = 0; i < children.getLength(); i++) {
            if (children.item(i).getNodeType() == Node.TEXT_NODE){
                String text = ((Text)children.item(i)).getData().trim();
                Node []newNodes = searchAndHighlight(node.getOwnerDocument(),text,query);
                if(newNodes == null) continue;
                if(newNodes[1] != null){
                    node.insertBefore(newNodes[1],children.item(i));
                    i++;
                }
                node.insertBefore(newNodes[0],children.item(i));
                children.item(i).appendChild(newNodes[2]);
                i++;
	        if(newNodes[3] != null){
	            node.insertBefore(newNodes[3], children.item(i));
	            i++;
	        }
	        node.removeChild(children.item(i));
                children = node.getChildNodes();
            }else{
                processNode(children.item(i),query);
            }
        }
    }
    
    
    private Node []searchAndHighlight(Document document,String text, String query){
        if(text == null || query == null || text.length() < 1) return null;
        int index = text.indexOf(query);
        if (index < 0) return null;
        Node []newText = new Node[4];
        String keyword = "";
        String prefix = "";
        String suffix = "";
        Element font = document.createElement("font");
        font.setAttribute("color", "yellow");
        newText[0] = font;
	if (index == 0){
            keyword = text.substring(0, query.length());
	}else{
            prefix = text.substring(0, index);
            keyword = text.substring(index, index + query.length());
        }
        if (index + query.length() < text.length())
	      suffix = text.substring(index + query.length());
        if (prefix.length() > 0) newText[1] = document.createTextNode(prefix);
        newText[2] = document.createTextNode(keyword);
        if (suffix.length() > 0) newText[3] = document.createTextNode(suffix);
	return newText;
    }

    protected void testDOM(){
        
        final DOMDocument document = new DOMDocument(this);

//        Element newElement = document.createElement("FONT");
//        newElement.setAttribute("color","0000FF");
//        System.out.println("newElement "+((ElementWrapper)newElement).getCreateString());




        Element rootElement = document.getDocumentElement();
        System.out.println("Test DOM. rootElement "+rootElement);
        if(rootElement instanceof NodeWrapper){
            ((NodeWrapper)rootElement).printNode();
            ((NodeWrapper)rootElement).testNode(document);
            reRenderDocument();
        }
        if(rootElement instanceof NodeWrapper){
            ((NodeWrapper)rootElement).printNode();
        }
        
       /* if(rootElement != null){
            NodeList nodeList = rootElement.getElementsByTagName("FONT");
            for(int i = 0; i < nodeList.getLength(); i++){
                Element element = (Element)nodeList.item(i);
                System.out.println("nodeList["+i+"] = "+element);
            }
        }*/
        
/*
        StringBuffer sb = new StringBuffer("var bodyElement = window.document.body;\n");
        sb.append("var text = window.document.createTextNode(\"dimatest\");\n");
        sb.append("var fontElement = window.document.createElement(\"FONT\");\n");
        sb.append("fontElement.setAttribute(\"color\",\"0000FF\");\n");
        sb.append("fontElement.appendChild(text);\n");
        sb.append("bodyElement.appendChild(fontElement);\n");
        System.out.println("<<<"+runJS(sb.toString())+">>>");
        final DOMDocument document = new DOMDocument(this);
        Element rootElement = document.getDocumentElement();
        System.out.println("Test DOM. rootElement "+rootElement);
        if(rootElement instanceof NodeWrapper){
            ((NodeWrapper)rootElement).printNode();
        }
*/
        repaint();
    }
//callback
    public void setURLTitle(String title){
        if(owner != null) owner.setTitle(title);
    }
    
//callback
    public void setURLIcon(java.nio.ByteBuffer buffer){
        if(iconHolder == null) return;
        iconHolder.setImage(null);
        if(buffer == null) return;
        try{
            byte []data = new byte[buffer.capacity()];
            buffer.get(data);
            java.io.ByteArrayInputStream bis = new java.io.ByteArrayInputStream(data);
            iconHolder.setImage(javax.imageio.ImageIO.read(bis));
            bis.close();
        }catch(Throwable t){
            System.out.println("setURLIcon Throwable "+t);
        }     
    }
//callback    
    public void setBackButtonEnable(boolean v){
        if(backButton != null) backButton.setEnabled(v);
    }
//callback
    public void setForwardButtonEnable(boolean v){
        if(forwardButton != null) forwardButton.setEnabled(v);
    }
    public void updateCursor(){
        sendMessage(DMWebKitView.updateCursor);
    }
    public boolean isFocusable(){return true;}
    
    public void mouseDidMoveOverElement(Object elementInfoObject){
        super.mouseDidMoveOverElement(elementInfoObject);
        if(!(elementInfoObject instanceof WebKitElementInfo)) return;
        setError(((WebKitElementInfo)elementInfoObject).linkURLString);
    }   
    
     
    public void loadURL(String url){
        setError("");
        Loader loader = new Loader(url,this);
        loader.start();
    }

    public void loadFromString(String html){
        loadFromString(html,null);
    }
    
    public void loadFromString(String html,String baseURL){
        setError("");
        LoaderFromMemory loader = new LoaderFromMemory(html,baseURL,this);
        loader.start();
    }   
}

class Loader extends Thread{
String url;
DMWebKitView owner;
    public Loader(String url, DMWebKitView owner){
        this.url = url;
        this.owner = owner;
    }
    public void run(){
        if(url == null || owner == null) return;
        owner.sendMessage(DMWebKitView.loadURL,url);
    }
 }

class LoaderFromMemory extends Thread{
String html;
String baseURL;
DMWebKitView owner;
    public LoaderFromMemory(String html, String baseURL,DMWebKitView owner){
        this.html = html;
        this.baseURL = baseURL;
        this.owner = owner;
    }
    public void run(){
        if(html == null || owner == null) return;
        owner.sendMessage(DMWebKitView.loadURLFromString,new String[]{html,baseURL});
    }
 }
 
 
 
class IconHolder extends JPanel{
BufferedImage bim;
Dimension ps = new Dimension(16,16);
    IconHolder(){
        setSize(getPreferredSize());
    }
    public void paintComponent(Graphics g){
        Graphics2D g2d = (Graphics2D)g.create();
        Dimension d = getSize();
        g2d.setColor(getBackground());
        g2d.fillRect(0,0,d.width,d.height);
        if(bim != null){
            int x2 = (d.width - bim.getWidth())/2;
            int y2 = (d.height - bim.getHeight())/2;
            g2d.drawImage(bim,null,x2,y2);
        }
        g2d.dispose();
    }
    public void setImage(BufferedImage bim){
        this.bim = bim;
        repaint();
    }
    public Dimension getPreferredSize(){return ps;}
}


class TestDOMSupport{
static String preambula;
String jsquery;
    TestDOMSupport(String query){
        if(preambula == null){
            StringBuffer sb = new StringBuffer();
            sb.append("function processNode(node, query){\n");
            sb.append("var children = node.childNodes;\n");
            sb.append("for (var i = 0; i < children.length; i++){\n");
            sb.append("if (children[i].nodeType == 3)\n");
            sb.append("{\n");
            sb.append("var text = children[i].nodeValue;\n");
            sb.append("var newNodes = searchAndHighlight(text, query);\n");
            sb.append("if (newNodes != null)\n");
            sb.append("{\n");
            sb.append("  if(newNodes[1] != null){\n");
            sb.append("      node.insertBefore(newNodes[1],children[i]);\n");
            sb.append("      i++;\n");
            sb.append("  }\n");
            sb.append("  node.insertBefore(newNodes[0],children[i]);\n");
            sb.append("  children[i].appendChild(newNodes[2]);\n");
            sb.append("  i++;\n");
            sb.append("if(newNodes[3] != null){\n");
            sb.append("  node.insertBefore(newNodes[3], children[i]);\n");
            sb.append("  i++;\n");
            sb.append("}\n");
            sb.append("node.removeChild(children[i]);\n");
            sb.append("}\n");
            sb.append("} \n");
            sb.append("else\n");
            sb.append("processNode(children[i], query);\n");
            sb.append("}\n");
            sb.append("}\n");


            sb.append("function searchAndHighlight(text, query)\n");
            sb.append("{\n");
            sb.append("  var index = text.indexOf(query);\n");
            sb.append("  if (index < 0)\n");
            sb.append("return null;\n");
            sb.append("  var newText = new Array(4);\n");
            sb.append("var keyword = \"\";\n");
            sb.append("var prefix = \"\";\n");
            sb.append("var suffix = \"\";\n");
            sb.append("  var font = document.createElement(\"font\");\n");
            sb.append("  font.setAttribute(\"color\", \"yellow\");\n");//Color
            sb.append("  newText[0] = font;\n");

            sb.append("if (index == 0)\n");
            sb.append("  keyword = text.substring(0, query.length);\n");
            sb.append("else\n");
            sb.append("{\n");
            sb.append("  prefix = text.substring(0, index);\n");
            sb.append("  keyword = text.substring(index, index + query.length);\n");
            sb.append("}\n");

            sb.append(" if (index + query.length < text.length)\n");
            sb.append("  suffix = text.substring(index + query.length);\n");

            sb.append("if (prefix != \"\") newText[1] = document.createTextNode(prefix);\n");
            sb.append("  newText[2] = document.createTextNode(keyword);\n");
            sb.append("if (suffix != \"\") newText[3] = document.createTextNode(suffix);\n");
            sb.append("return newText;\n");
            sb.append("}\n");
            
            sb.append("function highlight(query)\n");
            sb.append("{\n");
            sb.append("var root = document.body;\n");
            sb.append("processNode(root, query);\n");
            sb.append("}\n");
            preambula = sb.toString();
        }
        StringBuffer sb = new StringBuffer();
        sb.append("highlight('"+query+"')\n");
        jsquery = sb.toString();
    }
    String getQuery(){
        return preambula+jsquery;
    }
}
