/*
Copyright (c) 2004 Dmitry Markman, PhD dmarkman@mac.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package org.dm.webkit.dom;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.Attr;
import org.w3c.dom.DOMException;

import org.dm.webkit.DMWebKitView;

public class AttrWrapper extends NodeWrapper implements Attr{
String name;
String value;
Element ownerElement;
boolean specified = false;

    public AttrWrapper(DMWebKitView owner,String nodeAccessor,DOMDocument ownerDocument,Node parentNode){
        super(owner,nodeAccessor,ATTRIBUTE_NODE,ownerDocument,null);
        if(parentNode instanceof Element){
            ownerElement = (Element)parentNode;
        }
        name = owner.runJS(JSAccessors.getObjectPropertyAccessor(nodeAccessor,"name"));
        value = owner.runJS(JSAccessors.getObjectPropertyAccessor(nodeAccessor,"value"));
        String str = owner.runJS(JSAccessors.getObjectPropertyAccessor(nodeAccessor,"specified"));
        specified = str.equalsIgnoreCase("true");
    }
    
    public Element getOwnerElement(){return ownerElement;}
    
    public String toString(){
        return (name != null)?name+" = "+value:"";
    }
    
    public String getName(){return name;}
    
    public String getValue(){return value;}
    
    public void setValue(String val) throws DOMException{
        owner.runJS(nodeAccessor+".setValue(\""+val+"\")");
        value = owner.runJS(JSAccessors.getObjectPropertyAccessor(nodeAccessor,"value"));
    }
    
    public boolean getSpecified(){
        return specified;
    }
    
}

