/*
Copyright (c) 2004 Dmitry Markman, PhD dmarkman@mac.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package org.dm.webkit.dom;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.DOMException;

import org.dm.webkit.DMWebKitView;

public class NamedNodeMapWrapper extends AccessorHolder implements NamedNodeMap{
    DMWebKitView owner;
    int attrNumber;
    public NamedNodeMapWrapper(DMWebKitView owner,String nodeAccessor){
        this.nodeAccessor = nodeAccessor;
        this.owner = owner;
        attrNumber = JSAccessors.getIntFromString(owner.runJS(JSAccessors.getObjectPropertyAccessor(nodeAccessor,"length")));
        
    }
    
    public int getLength(){
        return getAttrNumber();
    }
    
    public int getAttrNumber(){return attrNumber;}
    
    public String getItemAccessor(int i){
        if(i < 0 || i >= getAttrNumber()) return "";
        return nodeAccessor+".item("+i+")";
    }
    
    public Node getNamedItem(String name){
        throw new RuntimeException("getNamedItem isn't implemented");
    }
    
    public Node getNamedItemNS(String namespaceURI, String localName){
        throw new RuntimeException("getNamedItemNS isn't implemented");
    }
    
    public Node item(int index){
        throw new RuntimeException("item isn't implemented");
    }
    
    public Node removeNamedItem(String name) throws DOMException{
        throw new RuntimeException("removeNamedItem isn't implemented");
    }
    
    public Node removeNamedItemNS(String namespaceURI,String localName) throws DOMException{
        throw new RuntimeException("removeNamedItemNS isn't implemented");
    }
    
    public Node setNamedItem(Node arg) throws DOMException{
        throw new RuntimeException("setNamedItem isn't implemented");
    }

    public Node setNamedItemNS(Node arg) throws DOMException{
        throw new RuntimeException("setNamedItemNS isn't implemented");
    }
}

